
<template>
  <div id="app" class="table">
    <div class="header year">2020</div>
    <div class="header horizontalHeader">
      <div v-for="(week, weekIndex) in weeks" :key="weekIndex" class="horizontalWeekday">
        <div v-for="(weekday, weekdayIndex) in weekdays" :key="weekdayIndex">{{weekday}}</div>
      </div>
    </div>
    <div class="header verticalMonth">
      <div v-for="(month, monthIndex) in months" :key="monthIndex">{{month}}</div>
    </div>
    <div>
      <div v-for="(month, monthIndex) in calendar" :key="monthIndex" class="month">
        <div v-for="(week, weekIndex) in month" :key="weekIndex" class="week">
          <div v-for="(day, dayIndex) in week" :key="dayIndex" class="day">{{day}}</div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import CalendarJs from "calendar-js";
const weeks = new Array(6).fill(null);
const weekdays = ["Mo", "Tu", "We", "Th", "Fr", "Sa", "Su"];
const months = [
  "Jan",
  "Feb",
  "Mar",
  "Apr",
  "May",
  "Jun",
  "Jul",
  "Aug",
  "Sep",
  "Oct",
  "Nov",
  "Dec"
];
const getMonthCalendar = index => CalendarJs().of(2020, index).calendar;
const buildCalendar = () =>
  new Array(12).fill().map((el, index) => getMonthCalendar(index));

export default {
  name: "app",
  data: () => ({
    calendar: buildCalendar(),
    weekdays,
    weeks,
    months
  })
};
</script>

<style>
#app {
  font-family: "Avenir", Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
  margin-top: 60px;
}
.table {
  border: 1px solid #c4c4c4;
  display: grid;
  grid-template-columns: 100px auto;
  grid-template-rows: 50px auto;
}
.header {
  background: #eaeaea;
  align-content: flex-end;
}
.month {
  width: 100%;
  grid-column-gap: 10px;
  display: grid;
  grid-template-rows: auto;
  grid-template-columns: repeat(6, 1fr);
}
.week {
  width: 100%;
  display: grid;
  grid-template-rows: auto;
  grid-template-columns: repeat(7, 1fr);
}
.day {
  border: 1px solid lightgray;
}

.selected {
  background: lightgreen;
}

.header.horizontalHeader {
  width: 100%;
  grid-column-gap: 10px;
  display: grid;
  grid-template-rows: auto;
  grid-template-columns: repeat(6, 1fr);
  grid-auto-columns: 20%;
}

.horizontalWeekday {
  width: 100%;
  display: grid;
  grid-template-rows: auto;
  grid-template-columns: repeat(7, 1fr);
}

.verticalMonth {
  height: 100%;
  display: grid;
  grid-auto-rows: 1fr;
  align-items: center;
  justify-content: end;
  padding: 0 5px;
}

.year {
  justify-content: flex-end;
  display: flex;
  align-items: flex-end;
  font-weight: bold;
  font-size: x-large;
}
</style>
